<?php

class ControllerModuleOutOfStockLabel extends Controller {

    private $error = array();

    public function index() {
        $this->load->language('module/out_of_stock_label');
        $this->load->model('module/out_of_stock_label');

        $this->document->setTitle($this->language->get('heading_title'));

        $this->load->model('setting/setting');

        $this->data = array();
        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
            $post = array();
            $post['out_of_stock_label_enabled'] = $this->request->post['out_of_stock_label_enabled'];
            $post['out_of_stock_label_style'] = $this->request->post['out_of_stock_label_style'];
            $post['out_of_stock_label_default_style'] = $this->config->get('out_of_stock_label_default_style');
            $post['out_of_stock_label_show_marker_in_product_page'] = $this->request->post['out_of_stock_label_show_marker_in_product_page'];

            $this->model_setting_setting->editSetting('out_of_stock_label', $post);

            $this->model_module_out_of_stock_label->updateLabels($this->request->post['out_of_stock_label_label']);

            $this->session->data['success'] = $this->language->get('text_success');
            $this->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
        }

        $this->data['heading_title'] = $this->language->get('heading_title');

        $this->data['text_edit'] = $this->language->get('text_edit');
        $this->data['text_enabled'] = $this->language->get('text_enabled');
        $this->data['text_disabled'] = $this->language->get('text_disabled');
        $this->data['text_yes'] = $this->language->get('text_yes');
        $this->data['text_no'] = $this->language->get('text_no');

        $this->data['entry_status'] = $this->language->get('entry_status');
        $this->data['entry_out_of_stock_label'] = $this->language->get('entry_out_of_stock_label');
        $this->data['entry_out_of_stock_label_show_marker_in_product_page'] = $this->language->get('entry_out_of_stock_label_show_marker_in_product_page');
        $this->data['entry_style'] = $this->language->get('entry_style');
        $this->data['entry_css_nodes'] = $this->language->get('entry_css_nodes');
        $this->data['entry_css_nodes_content'] = $this->language->get('entry_css_nodes_content');
        $this->data['entry_load_default_style'] = $this->language->get('entry_load_default_style');
        $this->data['entry_placeholder'] = $this->language->get('entry_placeholder');
        $this->data['entry_confirm_default_style_loading'] = $this->language->get('entry_confirm_default_style_loading');

        $this->data['button_save'] = $this->language->get('button_save');
        $this->data['button_cancel'] = $this->language->get('button_cancel');



        if (isset($this->error['warning'])) {
            $this->data['error_warning'] = $this->error['warning'];
        } else {
            $this->data['error_warning'] = '';
        }
        if (isset($this->error['label'])) {
            $this->data['error_label'] = $this->error['label'];
        } else {
            $this->data['error_label'] = array();
        }

        $this->data['breadcrumbs'] = array();

        $this->data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => false
        );

        $this->data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_module'),
            'href' => $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => ' :: '
        );

        $this->data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('module/out_of_stock_label', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => ' :: '
        );

        $this->data['action'] = $this->url->link('module/out_of_stock_label', 'token=' . $this->session->data['token'], 'SSL');

        $this->data['cancel'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL');

        // status
        if (isset($this->request->post['out_of_stock_label_enabled'])) {
            $this->data['out_of_stock_label_enabled'] = $this->request->post['out_of_stock_label_enabled'];
        } else {
            $this->data['out_of_stock_label_enabled'] = $this->config->get('out_of_stock_label_enabled');
        }
        // status
        if (isset($this->request->post['out_of_stock_label_show_marker_in_product_page'])) {
            $this->data['out_of_stock_label_show_marker_in_product_page'] = $this->request->post['out_of_stock_label_show_marker_in_product_page'];
        } else {
            $this->data['out_of_stock_label_show_marker_in_product_page'] = $this->config->get('out_of_stock_label_show_marker_in_product_page');
        }


        // label
        if (isset($this->request->post['out_of_stock_label_label'])) {
            $this->data['out_of_stock_label_label'] = $this->request->post['out_of_stock_label_label'];
        } else {
            $this->data['out_of_stock_label_label'] = $this->model_module_out_of_stock_label->getLabels();
        }

        // style
        if (isset($this->request->post['out_of_stock_label_style'])) {
            $this->data['out_of_stock_label_style'] = $this->request->post['out_of_stock_label_style'];
        } else {
            $this->data['out_of_stock_label_style'] = $this->config->get('out_of_stock_label_style');
        }
        // default style
        $this->data['out_of_stock_label_default_style'] = $this->config->get('out_of_stock_label_default_style');

        $this->template = 'module/out_of_stock_label.tpl';
        $this->children = array(
            'common/header',
            'common/footer'
        );

        $this->response->setOutput($this->render());
    }

    protected function validate() {
        //$this->error['label'] = array();
        $labels = $this->request->post['out_of_stock_label_label'];
        foreach ($labels as $key => $label) {
            if (empty($label['label'])) {
                $this->error['label'][$key] = $this->language->get('error_empty_line');
            }
        }
        if (!$this->user->hasPermission('modify', 'module/out_of_stock_label')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }

        return !$this->error;
    }

    public function install() {
        $this->load->model('setting/setting');
        $post = array();
        $post['out_of_stock_label_enabled'] = "1";
        $post['out_of_stock_label_show_marker_in_product_page'] = "1";
        $post['out_of_stock_label_style'] = $post['out_of_stock_label_default_style'] = ".box-product > div,
    .product-grid > div,
    .product-list >div .left
    {
        overflow: hidden;
        position: relative;
        padding-left: 10px;
    }

    .product-not-available{
        color: white;
        position: absolute;
        text-transform: uppercase;
        text-align: center;
        border: 3px white double;
        width: 200px;
        background-color: #b90909;
        margin-left: -74px;
        margin-top: 15px;
        -ms-transform: rotate(-45deg); 
        -webkit-transform: rotate(-45deg); 
        transform: rotate(-45deg);
        z-index: 3;
        height: 14px;
    }

    .product-not-available p{
        padding-top: 2px;
        width: 120px;
        margin: auto;
        font-size: 10px;
        margin-left: 34px;
    }

    .product-not-available:before{
        -ms-transform: rotate(45deg);
        -webkit-transform: rotate(45deg);
        transform: rotate(45deg);
        content: '*';
        color: transparent;
        position: absolute;
        z-index: -1;
        border-left: 10px solid transparent;
        border-bottom: 5px solid transparent;
        border-top: 10px solid transparent;
        border-right: 10px solid #890606;
        height: 0;
        width: 0;
        margin-left: -73px;
        margin-top: 8px;
    }

.not-available-mark{
    position: absolute;
    text-transform: uppercase;
    background-color: #b90909;
    color: white;
    font-size: 30px;
    padding: 10px;
    padding-left: 10px;
    padding-right: 10px;
    border: 5px white double;
    -ms-transform: rotate(-45deg); /* IE 9 */
    -webkit-transform: rotate(-45deg); /* Chrome, Safari, Opera */
    transform: rotate(-45deg);
    margin-top: 94px;
    text-align: center;
}";

        $this->model_setting_setting->editSetting('out_of_stock_label', $post);

        $this->load->model('module/out_of_stock_label');
        $this->model_module_out_of_stock_label->createOutOfStockLabelTable();
    }

    public function uninstall() {
        $this->load->model('module/out_of_stock_label');
        $this->model_module_out_of_stock_label->deleteOutOfStockLabelTable();
    }

}
